unit gl;

interface

uses	Windows, Messages, SysUtils, Classes;
 //ifndef __gl_h_
//const __gl_h_;

//ifdef __cplusplus
// 'C' begin 
//endif

(*
** License Applicability. Except to the extent portions of this file are
** made subject to an alternative license as permitted in the SGI Free
** Software License B, Version 1.0 (the 'License'), the contents of this
** file are subject only to the provisions of the License. You may not use
** this file except in compliance with the License. You may obtain a copy
** of the License at Silicon Graphics, Inc., attn: Legal Services, 1600
** Amphitheatre Parkway, Mountain View, CA 94043-1351, or at:
**
** http://oss.sgi.com/projects/FreeB
**
** Note that, as provided in the License, the Software is distributed on an
** 'AS IS' basis, with ALL EXPRESS AND IMPLIED WARRANTIES AND CONDITIONS
** DISCLAIMED, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES AND
** CONDITIONS OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A
** PARTICULAR PURPOSE, AND NON-INFRINGEMENT.
**
** Original Code. The Original Code is: OpenGL Sample Implementation,
** Version 1.2.1, released January 26, 2000, developed by Silicon Graphics,
** Inc. The Original Code is Copyright (c) 1991-2000 Silicon Graphics, Inc.
** Copyright in any portions created by third parties is as indicated
** elsewhere herein. All Rights Reserved.
**
** Additional Notice Provisions: The application programming interfaces
** established by SGI in conjunction with the Original Code are The
** OpenGL(R) Graphics System: A Specification (Version 1.2.1), released
** April 1, 1999; The OpenGL(R) Graphics System Utility Library (Version
** 1.3), released November 4, 1998; and OpenGL(R) Graphics with the X
** Window System(R) (Version 1.3), released October 19, 1998. This software
** was created using the OpenGL(R) version 1.2.1 Sample Implementation
** published by SGI, but has not been independently verified as being
** compliant with the OpenGL(R) version 1.2.1 Specification.
*)

//if defined(AEE_SIMULATOR)
//const __GL_EXPORTS;
//endif

//ifdef _WIN32
//   ifdef __GL_EXPORTS
//       define GL_API __declspec(dllexport)
//   else
//       define GL_API __declspec(dllimport)
//   endif
//else
//   ifdef __GL_EXPORTS
//       define GL_API
//   else
//       define GL_API
//   endif
//endif

//const GL_APIENTRY;

//ifndef GLAPI
//	define GLAPI GL_API
//endif


type
 GLenum= Word;
type
 GLboolean= Byte;
 PGLboolean=^GLboolean;
type
 GLbitfield= Word;
type
 GLbyte= ShortInt     ;
type
 GLshort= SmallInt           ;
 PGLshort=^GLshort;
type
 GLint= integer             ;
 PGLint=^GLint;
type
 GLsizei= integer             ;
type
 GLubyte= Byte   ;
 PGLubyte=^GLubyte;
type
 GLushort= Word  ;
type
 GLuint= Word    ;
 PGLuint= ^GLuint;
type
 GLfloat= Single           ;
 PGLfloat= ^GLfloat;
type
 GLclampf= Single           ;
type
 GLvoid= pointer            ;
 PGLvoid= pointer;
type
 GLfixed = integer             ;
 PGLfixed = ^GLFixed;
type
 GLclampx= integer             ;

type
 GLintptr= integer             ;
type
 GLsizeiptr = integer             ;


(*************************************************************)

(* OpenGL ES core versions *)
const GL_OES_VERSION_1_0 =               1;
const GL_OES_VERSION_1_1 =               1;

(* Extensions *)
const GL_OES_byte_coordinates =          1;
const GL_OES_compressed_paletted_texture =1;
const GL_OES_draw_texture =              1;
const GL_OES_fixed_point =               1;
const GL_OES_matrix_get =                1;
const GL_OES_matrix_palette =            1;
const GL_OES_point_size_array =          1;
const GL_OES_point_sprite =              1;
const GL_OES_read_format =               1;
const GL_OES_single_precision =          1;

(* ClearBufferMask *)
const GL_DEPTH_BUFFER_BIT =              $00000100;
const GL_STENCIL_BUFFER_BIT =            $00000400;
const GL_COLOR_BUFFER_BIT =              $00004000;

(* Boolean *)
const GL_FALSE =                         0;
const GL_TRUE =                          1;

(* BeginMode *)
const GL_POINTS =                        $0000;
const GL_LINES =                         $0001;
const GL_LINE_LOOP =                     $0002;
const GL_LINE_STRIP =                    $0003;
const GL_TRIANGLES =                     $0004;
const GL_TRIANGLE_STRIP =                $0005;
const GL_TRIANGLE_FAN =                  $0006;

(* AlphaFunction *)
const GL_NEVER =                         $0200;
const GL_LESS =                          $0201;
const GL_EQUAL =                         $0202;
const GL_LEQUAL =                        $0203;
const GL_GREATER =                       $0204;
const GL_NOTEQUAL =                      $0205;
const GL_GEQUAL =                        $0206;
const GL_ALWAYS =                        $0207;

(* BlendingFactorDest *)
const GL_ZERO =                          0;
const GL_ONE =                           1;
const GL_SRC_COLOR =                     $0300;
const GL_ONE_MINUS_SRC_COLOR =           $0301;
const GL_SRC_ALPHA =                     $0302;
const GL_ONE_MINUS_SRC_ALPHA =           $0303;
const GL_DST_ALPHA =                     $0304;
const GL_ONE_MINUS_DST_ALPHA =           $0305;

(* BlendingFactorSrc *)
(*      GL_ZERO *)
(*      GL_ONE *)
const GL_DST_COLOR =                     $0306;
const GL_ONE_MINUS_DST_COLOR =           $0307;
const GL_SRC_ALPHA_SATURATE =            $0308;
(*      GL_SRC_ALPHA *)
(*      GL_ONE_MINUS_SRC_ALPHA *)
(*      GL_DST_ALPHA *)
(*      GL_ONE_MINUS_DST_ALPHA *)

(* ClipPlaneName *)
const GL_CLIP_PLANE0 =                   $3000;
const GL_CLIP_PLANE1 =                   $3001;
const GL_CLIP_PLANE2 =                   $3002;
const GL_CLIP_PLANE3 =                   $3003;
const GL_CLIP_PLANE4 =                   $3004;
const GL_CLIP_PLANE5 =                   $3005;

(* ColorMaterialFace *)
(*      GL_FRONT_AND_BACK *)

(* ColorMaterialParameter *)
(*      GL_AMBIENT_AND_DIFFUSE *)

(* ColorPointerType *)
(*      GL_UNSIGNED_BYTE *)
(*      GL_FLOAT *)
(*      GL_FIXED *)

(* CullFaceMode *)
const GL_FRONT =                         $0404;
const GL_BACK =                          $0405;
const GL_FRONT_AND_BACK =                $0408;

(* DepthFunction *)
(*      GL_NEVER *)
(*      GL_LESS *)
(*      GL_EQUAL *)
(*      GL_LEQUAL *)
(*      GL_GREATER *)
(*      GL_NOTEQUAL *)
(*      GL_GEQUAL *)
(*      GL_ALWAYS *)

(* EnableCap *)
const GL_FOG =                           $0B60;
const GL_LIGHTING =                      $0B50;
const GL_TEXTURE_2D =                    $0DE1;
const GL_CULL_FACE =                     $0B44;
const GL_ALPHA_TEST =                    $0BC0;
const GL_BLEND =                         $0BE2;
const GL_COLOR_LOGIC_OP =                $0BF2;
const GL_DITHER =                        $0BD0;
const GL_STENCIL_TEST =                  $0B90;
const GL_DEPTH_TEST =                    $0B71;
(*      GL_LIGHT0 *)
(*      GL_LIGHT1 *)
(*      GL_LIGHT2 *)
(*      GL_LIGHT3 *)
(*      GL_LIGHT4 *)
(*      GL_LIGHT5 *)
(*      GL_LIGHT6 *)
(*      GL_LIGHT7 *)
const GL_POINT_SMOOTH =                  $0B10;
const GL_LINE_SMOOTH =                   $0B20;
const GL_SCISSOR_TEST =                  $0C11;
const GL_COLOR_MATERIAL =                $0B57;
const GL_NORMALIZE =                     $0BA1;
const GL_RESCALE_NORMAL =                $803A;
const GL_POLYGON_OFFSET_FILL =           $8037;
const GL_VERTEX_ARRAY =                  $8074;
const GL_NORMAL_ARRAY =                  $8075;
const GL_COLOR_ARRAY =                   $8076;
const GL_TEXTURE_COORD_ARRAY =           $8078;
const GL_MULTISAMPLE =                   $809D;
const GL_SAMPLE_ALPHA_TO_COVERAGE =      $809E;
const GL_SAMPLE_ALPHA_TO_ONE =           $809F;
const GL_SAMPLE_COVERAGE =               $80A0;

(* ErrorCode *)
const GL_NO_ERROR =                      0;
const GL_INVALID_ENUM =                  $0500;
const GL_INVALID_VALUE =                 $0501;
const GL_INVALID_OPERATION =             $0502;
const GL_STACK_OVERFLOW =                $0503;
const GL_STACK_UNDERFLOW =               $0504;
const GL_OUT_OF_MEMORY =                 $0505;

(* FogMode *)
(*      GL_LINEAR *)
const GL_EXP =                           $0800;
const GL_EXP2 =                          $0801;

(* FogParameter *)
const GL_FOG_DENSITY =                   $0B62;
const GL_FOG_START =                     $0B63;
const GL_FOG_END =                       $0B64;
const GL_FOG_MODE =                      $0B65;
const GL_FOG_COLOR =                     $0B66;

(* FrontFaceDirection *)
const GL_CW =                            $0900;
const GL_CCW =                           $0901;

(* GetPName *)
const GL_CURRENT_COLOR =                 $0B00;
const GL_CURRENT_NORMAL =                $0B02;
const GL_CURRENT_TEXTURE_COORDS =        $0B03;
const GL_POINT_SIZE =                    $0B11;
const GL_POINT_SIZE_MIN =                $8126;
const GL_POINT_SIZE_MAX =                $8127;
const GL_POINT_FADE_THRESHOLD_SIZE =     $8128;
const GL_POINT_DISTANCE_ATTENUATION =    $8129;
const GL_SMOOTH_POINT_SIZE_RANGE =       $0B12;
const GL_LINE_WIDTH =                    $0B21;
const GL_SMOOTH_LINE_WIDTH_RANGE =       $0B22;
const GL_ALIASED_POINT_SIZE_RANGE =      $846D;
const GL_ALIASED_LINE_WIDTH_RANGE =      $846E;
const GL_CULL_FACE_MODE =                $0B45;
const GL_FRONT_FACE =                    $0B46;
const GL_SHADE_MODEL =                   $0B54;
const GL_DEPTH_RANGE =                   $0B70;
const GL_DEPTH_WRITEMASK =               $0B72;
const GL_DEPTH_CLEAR_VALUE =             $0B73;
const GL_DEPTH_FUNC =                    $0B74;
const GL_STENCIL_CLEAR_VALUE =           $0B91;
const GL_STENCIL_FUNC =                  $0B92;
const GL_STENCIL_VALUE_MASK =            $0B93;
const GL_STENCIL_FAIL =                  $0B94;
const GL_STENCIL_PASS_DEPTH_FAIL =       $0B95;
const GL_STENCIL_PASS_DEPTH_PASS =       $0B96;
const GL_STENCIL_REF =                   $0B97;
const GL_STENCIL_WRITEMASK =             $0B98;
const GL_MATRIX_MODE =                   $0BA0;
const GL_VIEWPORT =                      $0BA2;
const GL_MODELVIEW_STACK_DEPTH =         $0BA3;
const GL_PROJECTION_STACK_DEPTH =        $0BA4;
const GL_TEXTURE_STACK_DEPTH =           $0BA5;
const GL_MODELVIEW_MATRIX =              $0BA6;
const GL_PROJECTION_MATRIX =             $0BA7;
const GL_TEXTURE_MATRIX =                $0BA8;
const GL_ALPHA_TEST_FUNC =               $0BC1;
const GL_ALPHA_TEST_REF =                $0BC2;
const GL_BLEND_DST =                     $0BE0;
const GL_BLEND_SRC =                     $0BE1;
const GL_LOGIC_OP_MODE =                 $0BF0;
const GL_SCISSOR_BOX =                   $0C10;
//const GL_SCISSOR_TEST =                  $0C11;
const GL_COLOR_CLEAR_VALUE =             $0C22;
const GL_COLOR_WRITEMASK =               $0C23;
const GL_UNPACK_ALIGNMENT =              $0CF5;
const GL_PACK_ALIGNMENT =                $0D05;
const GL_MAX_LIGHTS =                    $0D31;
const GL_MAX_CLIP_PLANES =               $0D32;
const GL_MAX_TEXTURE_SIZE =              $0D33;
const GL_MAX_MODELVIEW_STACK_DEPTH =     $0D36;
const GL_MAX_PROJECTION_STACK_DEPTH =    $0D38;
const GL_MAX_TEXTURE_STACK_DEPTH =       $0D39;
const GL_MAX_VIEWPORT_DIMS =             $0D3A;
const GL_MAX_ELEMENTS_VERTICES =         $80E8;
const GL_MAX_ELEMENTS_INDICES =          $80E9;
const GL_MAX_TEXTURE_UNITS =             $84E2;
const GL_SUBPIXEL_BITS =                 $0D50;
const GL_RED_BITS =                      $0D52;
const GL_GREEN_BITS =                    $0D53;
const GL_BLUE_BITS =                     $0D54;
const GL_ALPHA_BITS =                    $0D55;
const GL_DEPTH_BITS =                    $0D56;
const GL_STENCIL_BITS =                  $0D57;
const GL_POLYGON_OFFSET_UNITS =          $2A00;
//const GL_POLYGON_OFFSET_FILL =           $8037;
const GL_POLYGON_OFFSET_FACTOR =         $8038;
const GL_TEXTURE_BINDING_2D =            $8069;
const GL_VERTEX_ARRAY_SIZE =             $807A;
const GL_VERTEX_ARRAY_TYPE =             $807B;
const GL_VERTEX_ARRAY_STRIDE =           $807C;
const GL_NORMAL_ARRAY_TYPE =             $807E;
const GL_NORMAL_ARRAY_STRIDE =           $807F;
const GL_COLOR_ARRAY_SIZE =              $8081;
const GL_COLOR_ARRAY_TYPE =              $8082;
const GL_COLOR_ARRAY_STRIDE =            $8083;
const GL_TEXTURE_COORD_ARRAY_SIZE =      $8088;
const GL_TEXTURE_COORD_ARRAY_TYPE =      $8089;
const GL_TEXTURE_COORD_ARRAY_STRIDE =    $808A;
const GL_VERTEX_ARRAY_POINTER =          $808E;
const GL_NORMAL_ARRAY_POINTER =          $808F;
const GL_COLOR_ARRAY_POINTER =           $8090;
const GL_TEXTURE_COORD_ARRAY_POINTER =   $8092;
const GL_SAMPLE_BUFFERS =                $80A8;
const GL_SAMPLES =                       $80A9;
const GL_SAMPLE_COVERAGE_VALUE =         $80AA;
const GL_SAMPLE_COVERAGE_INVERT =        $80AB;

(* GetTextureParameter *)
(*      GL_TEXTURE_MAG_FILTER *)
(*      GL_TEXTURE_MIN_FILTER *)
(*      GL_TEXTURE_WRAP_S *)
(*      GL_TEXTURE_WRAP_T *)

const GL_IMPLEMENTATION_COLOR_READ_TYPE_OES =  $8B9A;
const GL_IMPLEMENTATION_COLOR_READ_FORMAT_OES =$8B9B;
const GL_NUM_COMPRESSED_TEXTURE_FORMATS =      $86A2;
const GL_COMPRESSED_TEXTURE_FORMATS =          $86A3;

(* HintMode *)
const GL_DONT_CARE =                     $1100;
const GL_FASTEST =                       $1101;
const GL_NICEST =                        $1102;

(* HintTarget *)
const GL_PERSPECTIVE_CORRECTION_HINT =   $0C50;
const GL_POINT_SMOOTH_HINT =             $0C51;
const GL_LINE_SMOOTH_HINT =              $0C52;
const GL_POLYGON_SMOOTH_HINT =           $0C53;
const GL_FOG_HINT =                      $0C54;
const GL_GENERATE_MIPMAP_HINT =          $8192;

(* LightModelParameter *)
const GL_LIGHT_MODEL_AMBIENT =           $0B53;
const GL_LIGHT_MODEL_TWO_SIDE =          $0B52;

(* LightParameter *)
const GL_AMBIENT =                       $1200;
const GL_DIFFUSE =                       $1201;
const GL_SPECULAR =                      $1202;
const GL_POSITION =                      $1203;
const GL_SPOT_DIRECTION =                $1204;
const GL_SPOT_EXPONENT =                 $1205;
const GL_SPOT_CUTOFF =                   $1206;
const GL_CONSTANT_ATTENUATION =          $1207;
const GL_LINEAR_ATTENUATION =            $1208;
const GL_QUADRATIC_ATTENUATION =         $1209;

(* DataType *)
const GL_BYTE =                          $1400;
const GL_UNSIGNED_BYTE =                 $1401;
const GL_SHORT =                         $1402;
const GL_UNSIGNED_SHORT =                $1403;
const GL_FLOAT =                         $1406;
const GL_FIXED =                         $140C;

(* LogicOp *)
const GL_CLEAR =                         $1500;
const GL_AND =                           $1501;
const GL_AND_REVERSE =                   $1502;
const GL_COPY =                          $1503;
const GL_AND_INVERTED =                  $1504;
const GL_NOOP =                          $1505;
const GL_XOR =                           $1506;
const GL_OR =                            $1507;
const GL_NOR =                           $1508;
const GL_EQUIV =                         $1509;
const GL_INVERT =                        $150A;
const GL_OR_REVERSE =                    $150B;
const GL_COPY_INVERTED =                 $150C;
const GL_OR_INVERTED =                   $150D;
const GL_NAND =                          $150E;
const GL_SET =                           $150F;

(* MaterialFace *)
(*      GL_FRONT_AND_BACK *)

(* MaterialParameter *)
const GL_EMISSION =                      $1600;
const GL_SHININESS =                     $1601;
const GL_AMBIENT_AND_DIFFUSE =           $1602;
(*      GL_AMBIENT *)
(*      GL_DIFFUSE *)
(*      GL_SPECULAR *)

(* MatrixMode *)
const GL_MODELVIEW =                     $1700;
const GL_PROJECTION =                    $1701;
const GL_TEXTURE =                       $1702;

(* NormalPointerType *)
(*      GL_BYTE *)
(*      GL_SHORT *)
(*      GL_FLOAT *)
(*      GL_FIXED *)

(* PixelFormat *)
const GL_ALPHA =                         $1906;
const GL_RGB =                           $1907;
const GL_RGBA =                          $1908;
const GL_LUMINANCE =                     $1909;
const GL_LUMINANCE_ALPHA =               $190A;

(* PixelStoreParameter *)
//const GL_UNPACK_ALIGNMENT =              $0CF5;
//const GL_PACK_ALIGNMENT =                $0D05;

(* PixelType *)
(*      GL_UNSIGNED_BYTE *)
const GL_UNSIGNED_SHORT_4_4_4_4 =        $8033;
const GL_UNSIGNED_SHORT_5_5_5_1 =        $8034;
const GL_UNSIGNED_SHORT_5_6_5 =          $8363;

(* ShadingModel *)
const GL_FLAT =                          $1D00;
const GL_SMOOTH =                        $1D01;

(* StencilFunction *)
(*      GL_NEVER *)
(*      GL_LESS *)
(*      GL_EQUAL *)
(*      GL_LEQUAL *)
(*      GL_GREATER *)
(*      GL_NOTEQUAL *)
(*      GL_GEQUAL *)
(*      GL_ALWAYS *)

(* StencilOp *)
(*      GL_ZERO *)
const GL_KEEP =                          $1E00;
const GL_REPLACE =                       $1E01;
const GL_INCR =                          $1E02;
const GL_DECR =                          $1E03;
(*      GL_INVERT *)

(* StringName *)
const GL_VENDOR =                        $1F00;
const GL_RENDERER =                      $1F01;
const GL_VERSION =                       $1F02;
const GL_EXTENSIONS =                    $1F03;

(* TexCoordPointerType *)
(*      GL_SHORT *)
(*      GL_FLOAT *)
(*      GL_FIXED *)
(*      GL_BYTE *)

(* TextureEnvMode *)
const GL_MODULATE =                      $2100;
const GL_DECAL =                         $2101;
(*      GL_BLEND *)
const GL_ADD =                           $0104;
(*      GL_REPLACE *)

(* TextureEnvParameter *)
const GL_TEXTURE_ENV_MODE =              $2200;
const GL_TEXTURE_ENV_COLOR =             $2201;

(* TextureEnvTarget *)
const GL_TEXTURE_ENV =                   $2300;

(* TextureMagFilter *)
const GL_NEAREST =                       $2600;
const GL_LINEAR =                        $2601;

(* TextureMinFilter *)
(*      GL_NEAREST *)
(*      GL_LINEAR *)
const GL_NEAREST_MIPMAP_NEAREST =        $2700;
const GL_LINEAR_MIPMAP_NEAREST =         $2701;
const GL_NEAREST_MIPMAP_LINEAR =         $2702;
const GL_LINEAR_MIPMAP_LINEAR =          $2703;

(* TextureParameterName *)
const GL_TEXTURE_MAG_FILTER =            $2800;
const GL_TEXTURE_MIN_FILTER =            $2801;
const GL_TEXTURE_WRAP_S =                $2802;
const GL_TEXTURE_WRAP_T =                $2803;
const GL_GENERATE_MIPMAP =               $8191;

(* TextureTarget *)
(*      GL_TEXTURE_2D *)

(* TextureUnit *)
const GL_TEXTURE0 =                      $84C0;
const GL_TEXTURE1 =                      $84C1;
const GL_TEXTURE2 =                      $84C2;
const GL_TEXTURE3 =                      $84C3;
const GL_TEXTURE4 =                      $84C4;
const GL_TEXTURE5 =                      $84C5;
const GL_TEXTURE6 =                      $84C6;
const GL_TEXTURE7 =                      $84C7;
const GL_TEXTURE8 =                      $84C8;
const GL_TEXTURE9 =                      $84C9;
const GL_TEXTURE10 =                     $84CA;
const GL_TEXTURE11 =                     $84CB;
const GL_TEXTURE12 =                     $84CC;
const GL_TEXTURE13 =                     $84CD;
const GL_TEXTURE14 =                     $84CE;
const GL_TEXTURE15 =                     $84CF;
const GL_TEXTURE16 =                     $84D0;
const GL_TEXTURE17 =                     $84D1;
const GL_TEXTURE18 =                     $84D2;
const GL_TEXTURE19 =                     $84D3;
const GL_TEXTURE20 =                     $84D4;
const GL_TEXTURE21 =                     $84D5;
const GL_TEXTURE22 =                     $84D6;
const GL_TEXTURE23 =                     $84D7;
const GL_TEXTURE24 =                     $84D8;
const GL_TEXTURE25 =                     $84D9;
const GL_TEXTURE26 =                     $84DA;
const GL_TEXTURE27 =                     $84DB;
const GL_TEXTURE28 =                     $84DC;
const GL_TEXTURE29 =                     $84DD;
const GL_TEXTURE30 =                     $84DE;
const GL_TEXTURE31 =                     $84DF;
const GL_ACTIVE_TEXTURE =                $84E0;
const GL_CLIENT_ACTIVE_TEXTURE =         $84E1;

(* TextureWrapMode *)
const GL_REPEAT =                        $2901;
const GL_CLAMP_TO_EDGE =                 $812F;

(* PixelInternalFormat *)
const GL_PALETTE4_RGB8_OES =             $8B90;
const GL_PALETTE4_RGBA8_OES =            $8B91;
const GL_PALETTE4_R5_G6_B5_OES =         $8B92;
const GL_PALETTE4_RGBA4_OES =            $8B93;
const GL_PALETTE4_RGB5_A1_OES =          $8B94;
const GL_PALETTE8_RGB8_OES =             $8B95;
const GL_PALETTE8_RGBA8_OES =            $8B96;
const GL_PALETTE8_R5_G6_B5_OES =         $8B97;
const GL_PALETTE8_RGBA4_OES =            $8B98;
const GL_PALETTE8_RGB5_A1_OES =          $8B99;

(* VertexPointerType *)
(*      GL_SHORT *)
(*      GL_FLOAT *)
(*      GL_FIXED *)
(*      GL_BYTE *)

(* LightName *)
const GL_LIGHT0 =                        $4000;
const GL_LIGHT1 =                        $4001;
const GL_LIGHT2 =                        $4002;
const GL_LIGHT3 =                        $4003;
const GL_LIGHT4 =                        $4004;
const GL_LIGHT5 =                        $4005;
const GL_LIGHT6 =                        $4006;
const GL_LIGHT7 =                        $4007;

(* Buffer Objects *)
const GL_ARRAY_BUFFER =                  $8892;
const GL_ELEMENT_ARRAY_BUFFER =          $8893;

const GL_ARRAY_BUFFER_BINDING =          $8894;
const GL_ELEMENT_ARRAY_BUFFER_BINDING =  $8895;
const GL_VERTEX_ARRAY_BUFFER_BINDING =   $8896;
const GL_NORMAL_ARRAY_BUFFER_BINDING =   $8897;
const GL_COLOR_ARRAY_BUFFER_BINDING =    $8898;
const GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING =$889A;

const GL_STATIC_DRAW =                   $88E4;
const GL_DYNAMIC_DRAW =                  $88E8;

const GL_WRITE_ONLY =                    $88B9;

const GL_BUFFER_SIZE =                   $8764;
const GL_BUFFER_USAGE =                  $8765;
const GL_BUFFER_ACCESS =                 $88BB;


(* Texture combine + dot3 *)
const GL_SUBTRACT =                      $84E7;
const GL_COMBINE =                       $8570;
const GL_COMBINE_RGB =                   $8571;
const GL_COMBINE_ALPHA =                 $8572;
const GL_RGB_SCALE =                     $8573;
const GL_ADD_SIGNED =                    $8574;
const GL_INTERPOLATE =                   $8575;
const GL_CONSTANT =                      $8576;
const GL_PRIMARY_COLOR =                 $8577;
const GL_PREVIOUS =                      $8578;
const GL_OPERAND0_RGB =                  $8590;
const GL_OPERAND1_RGB =                  $8591;
const GL_OPERAND2_RGB =                  $8592;
const GL_OPERAND0_ALPHA =                $8598;
const GL_OPERAND1_ALPHA =                $8599;
const GL_OPERAND2_ALPHA =                $859A;

const GL_ALPHA_SCALE =                   $0D1C;

const GL_SRC0_RGB =                      $8580;
const GL_SRC1_RGB =                      $8581;
const GL_SRC2_RGB =                      $8582;
const GL_SRC0_ALPHA =                    $8588;
const GL_SRC1_ALPHA =                    $8589;
const GL_SRC2_ALPHA =                    $858A;

const GL_DOT3_RGB =                      $86AE;
const GL_DOT3_RGBA =                     $86AF;

(*****************************************************************************************)
(*                                 OES extension functions                               *)
(*****************************************************************************************)

(* OES_draw_texture *)
const GL_TEXTURE_CROP_RECT_OES =         $8B9D;

(* OES_matrix_get *)
const GL_MODELVIEW_MATRIX_FLOAT_AS_INT_BITS_OES =  $898D;
const GL_PROJECTION_MATRIX_FLOAT_AS_INT_BITS_OES = $898E;
const GL_TEXTURE_MATRIX_FLOAT_AS_INT_BITS_OES =    $898F;

(* OES_matrix_palette *)
const GL_MAX_VERTEX_UNITS_OES =          $86A4;
const GL_MAX_PALETTE_MATRICES_OES =      $8842;
const GL_MATRIX_PALETTE_OES =            $8840;
const GL_MATRIX_INDEX_ARRAY_OES =        $8844;
const GL_WEIGHT_ARRAY_OES =              $86AD;

const GL_MATRIX_INDEX_ARRAY_SIZE_OES =   $8846;
const GL_MATRIX_INDEX_ARRAY_TYPE_OES =   $8847;
const GL_MATRIX_INDEX_ARRAY_STRIDE_OES = $8848;
const GL_MATRIX_INDEX_ARRAY_POINTER_OES =$8849;
const GL_MATRIX_INDEX_ARRAY_BUFFER_BINDING_OES =$8B9E;

const GL_WEIGHT_ARRAY_SIZE_OES =         $86AB;
const GL_WEIGHT_ARRAY_TYPE_OES =         $86A9;
const GL_WEIGHT_ARRAY_STRIDE_OES =       $86AA;
const GL_WEIGHT_ARRAY_POINTER_OES =      $86AC;
const GL_WEIGHT_ARRAY_BUFFER_BINDING_OES =$889E;

(* OES_point_size_array *)
const GL_POINT_SIZE_ARRAY_OES =          $8B9C;
const GL_POINT_SIZE_ARRAY_TYPE_OES =     $898A;
const GL_POINT_SIZE_ARRAY_STRIDE_OES =   $898B;
const GL_POINT_SIZE_ARRAY_POINTER_OES =  $898C;
const GL_POINT_SIZE_ARRAY_BUFFER_BINDING_OES =$8B9F;

(* OES_point_sprite *)
const GL_POINT_SPRITE_OES =              $8861;
const GL_COORD_REPLACE_OES =             $8862;


(*************************************************************)

procedure glAlphaFunc (func: GLenum ; ref: GLclampf ); stdcall; external 'gles_ml.dll';
procedure glClearColor (red: GLclampf ; green: GLclampf ; blue: GLclampf ; alpha: GLclampf ); stdcall; external 'libgles_cl.dll';
procedure glClearDepthf (depth: GLclampf ); stdcall; external 'libgles_cl.dll';
procedure glClipPlanef (plane: GLenum ; const equation: PGLfloat ); stdcall; external 'libgles_cl.dll'; //*equation
procedure glColor4f (red: GLfloat ; green: GLfloat; blue: GLfloat ; alpha: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glDepthRangef (zNear: GLclampf ; zFar: GLclampf ); stdcall; external 'libgles_cl.dll';
procedure glFogf (pname: GLenum ; param: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glFogfv (pname: GLenum ; const params: PGLfloat); stdcall; external 'libgles_cl.dll'; //*params
procedure glFrustumf (left: GLfloat ; right: GLfloat ; bottom: GLfloat ; top: GLfloat ; zNear: GLfloat ; zFar: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glGetClipPlanef (pname: GLenum ; eqn: GLfloat ); stdcall; external 'libgles_cl.dll';  //egn[4]
procedure glGetFloatv (pname: GLenum ; params: PGLfloat); stdcall; external 'libgles_cl.dll'; //*params
procedure glGetLightfv (light: GLenum ; pname: GLenum ; params: PGLfloat); stdcall; external 'libgles_cl.dll'; //*params
procedure glGetMaterialfv (face: GLenum ; pname: GLenum ;  params: PGLfloat); stdcall; external 'libgles_cl.dll'; //*params
procedure glGetTexEnvfv (env: GLenum ; pname: GLenum; params: PGLfloat); stdcall; external 'libgles_cl.dll'; //*params
procedure glGetTexParameterfv (target: GLenum ; pname: GLenum ; params: PGLfloat ); stdcall; external 'libgles_cl.dll'; //*params
procedure glLightModelf (pname: GLenum; param: GLfloat); stdcall; external 'libgles_cl.dll';
procedure glLightModelfv (pname: GLenum; const params: PGLfloat ); stdcall; external 'libgles_cl.dll'; //*params
procedure glLightf (light: GLenum ; pname: GLenum ; param: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glLightfv (light: GLenum ; pname: GLenum ; const params: PGLfloat ); stdcall; external 'libgles_cl.dll'; //*params
procedure glLineWidth (width: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glLoadMatrixf (const m: PGLfloat); stdcall; external 'libgles_cl.dll'; //*m
procedure glMaterialf (face: GLenum ; pname: GLenum; param: GLfloat); stdcall; external 'libgles_cl.dll';
procedure glMaterialfv (face: GLenum ; pname: GLenum ; const params: PGLfloat ); stdcall; external 'libgles_cl.dll'; //*params
procedure glMultMatrixf (const m: PGLfloat); stdcall; external 'libgles_cl.dll'; //*m
procedure glMultiTexCoord4f (target: GLenum ; s: GLfloat ; t: GLfloat ; r: GLfloat ; q: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glNormal3f (nx: GLfloat ; ny: GLfloat ; nz: GLfloat); stdcall; external 'libgles_cl.dll';
procedure glOrthof (left: GLfloat; right: GLfloat ; bottom: GLfloat ; top: GLfloat ; zNear: GLfloat ; zFar: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glPointParameterf (pname: GLenum ; param: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glPointParameterfv (pname: GLenum ; const params: PGLfloat); stdcall; external 'libgles_cl.dll'; //*params
procedure glPointSize (size: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glPolygonOffset (factor: GLfloat ; units: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glRotatef (angle: GLfloat ; x: GLfloat ; y: GLfloat ; z: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glScalef (x: GLfloat; y: GLfloat ; z:GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glTexEnvf (target: GLenum ; pname: GLenum ; param: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glTexEnvfv (target: GLenum ; pname: GLenum ; const params: PGLfloat ); stdcall; external 'libgles_cl.dll'; //*params
procedure glTexParameterf (target: GLenum ; pname: GLenum ; param: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glTexParameterfv (target: GLenum ; pname: GLenum ; const params: PGLfloat); stdcall; external 'libgles_cl.dll'; //*params
procedure glTranslatef (x: GLfloat ; y: GLfloat ; z: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure glActiveTexture (texture: GLenum ); stdcall; external 'libgles_cl.dll';
procedure glAlphaFuncx (func: GLenum ; ref: GLclampx ); stdcall; external 'libgles_cl.dll';
procedure glBindBuffer (target: GLenum ; buffer: GLuint ); stdcall; external 'libgles_cl.dll';
procedure glBindTexture (target: GLenum ; texture: GLuint ); stdcall; external 'libgles_cl.dll';
procedure glBlendFunc (sfactor: GLenum ; dfactor: GLenum ); stdcall; external 'libgles_cl.dll';
procedure glBufferData (target: GLenum ; size: GLsizeiptr ; const data: PGLvoid; usage: GLenum ); stdcall; external 'libgles_cl.dll'; //*data
procedure glBufferSubData (target: GLenum ; offset: GLintptr ; size: GLsizeiptr ; const data: PGLvoid); stdcall; external 'libgles_cl.dll'; //*data
procedure glClear (mask: GLbitfield ); stdcall; external 'libgles_cl.dll';
procedure glClearColorx (red: GLclampx ; green: GLclampx ; blue: GLclampx ; alpha: GLclampx ); stdcall; external 'libgles_cl.dll';
procedure glClearDepthx (depth: GLclampx ); stdcall; external 'libgles_cl.dll';
procedure glClearStencil (s: GLint ); stdcall; external 'libgles_cl.dll';
procedure glClientActiveTexture (texture: GLenum ); stdcall; external 'libgles_cl.dll';
procedure glClipPlanex (plane: GLenum ; const equation: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*equation
procedure glColor4ub (red: GLubyte ; green: GLubyte ; blue: GLubyte ; alpha: GLubyte ); stdcall; external 'libgles_cl.dll';
procedure glColor4x (red: GLfixed ; green: GLfixed ; blue: GLfixed ; alpha: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glColorMask (red: GLboolean ; green: GLboolean ; blue:GLboolean ; alpha: GLboolean ); stdcall; external 'libgles_cl.dll';
procedure glColorPointer (size: GLint ; atype:GLenum ; stride: GLsizei ; const pointer: GLvoid); stdcall; external 'libgles_cl.dll'; //*pointer
procedure glCompressedTexImage2D (target: GLenum ; level: GLint ; internalformat: GLenum ; width: GLsizei ; height:GLsizei ; border: GLint ; imageSize: GLsizei ; const data: PGLvoid); stdcall; external 'libgles_cl.dll'; //*data
procedure glCompressedTexSubImage2D (target: GLenum ; level:GLint ; xoffset: GLint ; yoffset: GLint ; width: GLsizei ; height: GLsizei ; format: GLenum ; imageSize: GLsizei ; const data: PGLvoid ); stdcall; external 'libgles_cl.dll'; //*data
procedure glCopyTexImage2D (target: GLenum ; level: GLint ; internalformat:GLenum ; x: GLint ; y: GLint ; width: GLsizei ; height: GLsizei ; border: GLint ); stdcall; external 'libgles_cl.dll';
procedure glCopyTexSubImage2D (target: GLenum ; level: GLint ; xoffset: GLint ; yoffset: GLint ; x: GLint ; y: GLint ; width: GLsizei ; height: GLsizei ); stdcall; external 'libgles_cl.dll';
procedure glCullFace (mode: GLenum ); stdcall; external 'libgles_cl.dll';
procedure glDeleteBuffers (n: GLsizei; const buffers: PGLuint ); stdcall; external 'libgles_cl.dll'; //*buffers
procedure glDeleteTextures (n: GLsizei; const textures: PGLuint ); stdcall; external 'libgles_cl.dll'; //*textures
procedure glDepthFunc (func: GLenum ); stdcall; external 'libgles_cl.dll';
procedure glDepthMask (flag: GLboolean ); stdcall; external 'libgles_cl.dll';
procedure glDepthRangex (zNear: GLclampx ; zFar: GLclampx ); stdcall; external 'libgles_cl.dll';
procedure glDisable (cap: GLenum ); stdcall; external 'libgles_cl.dll';
procedure glDisableClientState (marray: GLenum ); stdcall; external 'libgles_cl.dll'; //array
procedure glDrawArrays (mode: GLenum ; first: GLint ; count: GLsizei ); stdcall; external 'libgles_cl.dll';
procedure glDrawElements (mode: GLenum ; count: GLsizei ; atype: GLenum; const indices: PGLvoid ); stdcall; external 'libgles_cl.dll'; //*indices
procedure glEnable (cap: GLenum ); stdcall; external 'libgles_cl.dll';
procedure glEnableClientState (marray: GLenum ); stdcall; external 'libgles_cl.dll'; //array
procedure glFinish ; stdcall; external 'libgles_cl.dll';
procedure glFlush ; stdcall; external 'libgles_cl.dll';
procedure glFogx (pname: GLenum ; param: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glFogxv (pname: GLenum ; const params: PGLfixed); stdcall; external 'libgles_cl.dll';  //*params
procedure glFrontFace (mode: GLenum ); stdcall; external 'libgles_cl.dll';
procedure glFrustumx (left: GLfixed ; right: GLfixed ; bottom: GLfixed ; top: GLfixed ; zNear: GLfixed ; zFar: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glGetBooleanv (pname: GLenum ; params: PGLboolean ); stdcall; external 'libgles_cl.dll'; //*params
procedure glGetBufferParameteriv (target: GLenum ; pname: GLenum ; params: PGLint ); stdcall; external 'libgles_cl.dll'; //*params
procedure glGetClipPlanex (pname: GLenum ; eqn: GLfixed ); stdcall; external 'libgles_cl.dll'; //eqn[4]
procedure glGenBuffers (n: GLsizei ; buffers: PGLuint ); stdcall; external 'libgles_cl.dll'; //*buffers
procedure glGenTextures (n: GLsizei ; textures: PGLuint ); stdcall; external 'libgles_cl.dll'; //*textures
function  glgetError(): GLenum ; stdcall; external 'libgles_cl.dll';
procedure glGetFixedv (pname: GLenum ; params: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*params
procedure glGetIntegerv (pname: GLenum ; params: PGLint ); stdcall; external 'libgles_cl.dll'; //*params
procedure glGetLightxv (light: GLenum ; pname: GLenum ; params: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*params
procedure glGetMaterialxv (face: GLenum ;pname: GLenum ; params: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*params
procedure glGetPointerv (pname: GLenum ; params: Pointer ); stdcall; external 'libgles_cl.dll'; //*params
function  glGetString (name: GLenum ): PGLubyte; stdcall; external 'libgles_cl.dll'; //const GLubyte *;
procedure glGetTexEnviv (env: GLenum ; pname: GLenum ; params: PGLint ); stdcall; external 'libgles_cl.dll'; //*params
procedure glGetTexEnvxv (env: GLenum ; pname: GLenum ; params: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*params
procedure glGetTexParameteriv (target: GLenum ; pname: GLenum ; params: PGLint ); stdcall; external 'libgles_cl.dll'; //*params
procedure glGetTexParameterxv (target: GLenum ; pname: GLenum ; params: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*params
procedure glHint (target: GLenum ; mode: GLenum ); stdcall; external 'libgles_cl.dll';
function glIsBuffer (buffer: GLuint ): GLboolean; stdcall; external 'libgles_cl.dll';
function glIsEnabled (cap: GLenum ): GLboolean; stdcall; external 'libgles_cl.dll';
function glIsTexture (texture: GLuint ): GLboolean; stdcall; external 'libgles_cl.dll';
procedure glLightModelx (pname: GLenum ; param: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glLightModelxv (pname: GLenum ; const params: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*params
procedure glLightx (light: GLenum ; pname: GLenum; param: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glLightxv (light: GLenum ; pname: GLenum ; const params: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*params
procedure glLineWidthx (width: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glLoadIdentity ; stdcall; external 'libgles_cl.dll';
procedure glLoadMatrixx (const m: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*m
procedure glLogicOp (opcode: GLenum ); stdcall; external 'libgles_cl.dll';
procedure glMaterialx (face: GLenum ; pname: GLenum ; param: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glMaterialxv (face: GLenum ; pname: GLenum ; const params: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*params
procedure glMatrixMode (mode: GLenum ); stdcall; external 'libgles_cl.dll';
procedure glMultMatrixx (const m: PGLfixed); stdcall; external 'libgles_cl.dll'; //*m
procedure glMultiTexCoord4x (target: GLenum ; s: GLfixed ; t: GLfixed ; r: GLfixed ; q: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glNormal3x (nx: GLfixed ; ny: GLfixed ; nz: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glNormalPointer (atype: GLenum ; stride: GLsizei ; const pointer: PGLvoid ); stdcall; external 'libgles_cl.dll'; //*pointer
procedure glOrthox (left: GLfixed ; right: GLfixed ; bottom: GLfixed ; top: GLfixed ; zNear: GLfixed ; zFar: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glPixelStorei (pname: GLenum ; param: GLint ); stdcall; external 'libgles_cl.dll';
procedure glPointParameterx (pname: GLenum ; param: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glPointParameterxv (pname: GLenum ; const params: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*params
procedure glPointSizex (size: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glPolygonOffsetx (factor: GLfixed ; units: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glPopMatrix ; stdcall; external 'libgles_cl.dll';
procedure glPushMatrix ; stdcall; external 'libgles_cl.dll';
procedure glReadPixels (x: GLint ; y: GLint ; width: GLsizei ; height: GLsizei ; format: GLenum ; atype: GLenum ; pixels: PGLvoid); stdcall; external 'libgles_cl.dll'; //*pixels
procedure glRotatex (angle: GLfixed ; x: GLfixed ; y: GLfixed ; z: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glSampleCoverage (value: GLclampf ; invert: GLboolean ); stdcall; external 'libgles_cl.dll';
procedure glSampleCoveragex (value: GLclampx ; invert: GLboolean ); stdcall; external 'libgles_cl.dll';
procedure glScalex (x: GLfixed ; y: GLfixed ; z: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glScissor (x: GLint ; y: GLint ; width:GLsizei ; height: GLsizei ); stdcall; external 'libgles_cl.dll';
procedure glShadeModel (mode: GLenum ); stdcall; external 'libgles_cl.dll';
procedure glStencilFunc (func: GLenum ; ref: GLint ; mask: GLuint ); stdcall; external 'libgles_cl.dll';
procedure glStencilMask (mask: GLuint ); stdcall; external 'libgles_cl.dll';
procedure glStencilOp (fail: GLenum ; zfail: GLenum ; zpass: GLenum ); stdcall; external 'libgles_cl.dll';
procedure glTexCoordPointer (size: GLint ; atype: GLenum ; stride: GLsizei ; const pointer: PGLvoid ); stdcall; external 'libgles_cl.dll'; //*pointer
procedure glTexEnvi (target: GLenum ; pname: GLenum ; param: GLint ); stdcall; external 'libgles_cl.dll';
procedure glTexEnvx (target: GLenum ; pname: GLenum ; param: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glTexEnviv (target: GLenum ; pname: GLenum ; const params: PGLint ); stdcall; external 'libgles_cl.dll'; //*params
procedure glTexEnvxv (target: GLenum ; pname: GLenum ; const params: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*params
procedure glTexImage2D (target: GLenum ; level: GLint ; internalformat: GLint ; width: GLsizei ; height: GLsizei ;border: GLint ; format: GLenum ; atype: GLenum ; const pixels: PGLvoid ); stdcall; external 'libgles_cl.dll'; //*pixels
procedure glTexParameteri (target: GLenum ; pname: GLenum ; param: GLint ); stdcall; external 'libgles_cl.dll';
procedure glTexParameterx (target: GLenum ; pname: GLenum ; param: GLfixed ); stdcall; external 'libgles_cl.dll';
procedure glTexParameteriv (target: GLenum ; pname: GLenum ; const params: PGLint ); stdcall; external 'libgles_cl.dll';
procedure glTexParameterxv (target: GLenum ; pname: GLenum ; const params: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*params
procedure glTexSubImage2D (target: GLenum ; level: GLint ; xoffset: GLint ; yoffset: GLint ; width: GLsizei ; height: GLsizei ; format: GLenum ; atype: GLenum ; const pixels: PGLvoid ); stdcall; external 'libgles_cl.dll'; //*pixels
procedure glTranslatex (x: GLfixed ; y: GLfixed ; z: GLfixed); stdcall; external 'libgles_cl.dll';
procedure glVertexPointer (size: GLint ; atype: GLenum ; stride: GLsizei ; const pointer: PGLvoid ); stdcall; external 'libgles_cl.dll'; //*pointer
procedure glViewport (x: GLint ; y: GLint ; width: GLsizei ; height: GLsizei ); stdcall; external 'libgles_cl.dll';


(*****************************************************************************************)
(*                                 OES extension functions                               *)
(*****************************************************************************************)

(* OES_matrix_palette *)
procedure  glCurrentPaletteMatrixOES (matrixpaletteindex: GLuint ); stdcall; external 'libgles_cl.dll';
procedure  glLoadPaletteFromModelViewMatrixOES ; stdcall; external 'libgles_cl.dll';
procedure  glMatrixIndexPointerOES (size: GLint ; atype: GLenum ; stride: GLsizei ; const pointer: PGLvoid ); stdcall; external 'libgles_cl.dll'; //*pointer
procedure  glWeightPointerOES (size: GLint ; atype: GLenum ; stride: GLsizei ; const pointer: PGLvoid ); stdcall; external 'libgles_cl.dll'; //*pointer

(* OES_point_size_array *)
procedure  glPointSizePointerOES (atype: GLenum ; stride: GLsizei ; const pointer: PGLvoid ); stdcall; external 'libgles_cl.dll';//*pointer

(* OES_draw_texture *)
procedure  glDrawTexsOES (x: GLshort ; y: GLshort ; z:GLshort ; width: GLshort ; height: GLshort ); stdcall; external 'libgles_cl.dll';
procedure  glDrawTexiOES (x: GLint ; y: GLint ; z:GLint ; width: GLint ; height: GLint ); stdcall; external 'libgles_cl.dll';
procedure  glDrawTexxOES (x: GLfixed ; y: GLfixed ; z:GLfixed ; width: GLfixed ; height: GLfixed ); stdcall; external 'libgles_cl.dll';

procedure  glDrawTexsvOES (const coords: PGLshort); stdcall; external 'libgles_cl.dll'; //*coords
procedure  glDrawTexivOES (const coords: PGLint ); stdcall; external 'libgles_cl.dll'; //*coords
procedure  glDrawTexxvOES (const coords: PGLfixed ); stdcall; external 'libgles_cl.dll'; //*coords

procedure  glDrawTexfOES (x: GLfloat; y: GLfloat ; z: GLfloat ; width: GLfloat ; height: GLfloat ); stdcall; external 'libgles_cl.dll';
procedure  glDrawTexfvOES (const coords: PGLfloat); stdcall; external 'libgles_cl.dll'; //*coords

implementation
end.